Index: Scheduling/branches/Radiology-Support/cs/bsdx0200GUISourceCode/CGView.cs
===================================================================
--- Scheduling/branches/Radiology-Support/cs/bsdx0200GUISourceCode/CGView.cs	(revision 1166)
+++ Scheduling/branches/Radiology-Support/cs/bsdx0200GUISourceCode/CGView.cs	(revision 1168)
@@ -94,10 +94,10 @@
 		private System.Windows.Forms.MenuItem sepApptMenu2;
 		private System.Windows.Forms.MenuItem ctxCalGridWalkin;
-		private System.Windows.Forms.MenuItem menuItem2;
-		private System.Windows.Forms.MenuItem menuItem9;
+		private System.Windows.Forms.MenuItem ctxCalGridSep1;
+		private System.Windows.Forms.MenuItem ctxCalGridSep2;
 		private System.Windows.Forms.MenuItem mnuOpenMultipleSchedules;
 		private System.Windows.Forms.MenuItem mnuDisplayWalkIns;
         private System.Windows.Forms.MenuItem mnuRPMSDivision;
-        private MenuItem menuItem10;
+        private MenuItem ctxCalGridSep3;
         private MenuItem ctxCalGridReprintApptSlip;
         private MenuItem ctxCalGridUndoCheckin;
@@ -257,5 +257,4 @@
             this.lblResource = new System.Windows.Forms.Label();
             this.panelCenter = new System.Windows.Forms.Panel();
-            this.calendarGrid1 = new IndianHealthService.ClinicalScheduling.CalendarGrid();
             this.ctxCalendarGrid = new System.Windows.Forms.ContextMenu();
             this.ctxCalGridAdd = new System.Windows.Forms.MenuItem();
@@ -266,10 +265,10 @@
             this.ctxCalGridCheckIn = new System.Windows.Forms.MenuItem();
             this.ctxCalGridUndoCheckin = new System.Windows.Forms.MenuItem();
-            this.menuItem2 = new System.Windows.Forms.MenuItem();
+            this.ctxCalGridSep1 = new System.Windows.Forms.MenuItem();
             this.ctxCalGridNoShow = new System.Windows.Forms.MenuItem();
             this.ctxCalGridNoShowUndo = new System.Windows.Forms.MenuItem();
-            this.menuItem9 = new System.Windows.Forms.MenuItem();
+            this.ctxCalGridSep2 = new System.Windows.Forms.MenuItem();
             this.ctxCalGridWalkin = new System.Windows.Forms.MenuItem();
-            this.menuItem10 = new System.Windows.Forms.MenuItem();
+            this.ctxCalGridSep3 = new System.Windows.Forms.MenuItem();
             this.ctxCalGridReprintApptSlip = new System.Windows.Forms.MenuItem();
             this.panelBottom = new System.Windows.Forms.Panel();
@@ -277,4 +276,5 @@
             this.splitter1 = new System.Windows.Forms.Splitter();
             this.splitter2 = new System.Windows.Forms.Splitter();
+            this.calendarGrid1 = new IndianHealthService.ClinicalScheduling.CalendarGrid();
             this.panelRight.SuspendLayout();
             this.panelClip.SuspendLayout();
@@ -384,5 +384,5 @@
             // 
             this.mnuPrintReminderLetters.Index = 10;
-            this.mnuPrintReminderLetters.Shortcut = System.Windows.Forms.Shortcut.CtrlI;
+            this.mnuPrintReminderLetters.Shortcut = System.Windows.Forms.Shortcut.CtrlE;
             this.mnuPrintReminderLetters.Text = "Print Rem&inder Letters";
             this.mnuPrintReminderLetters.Click += new System.EventHandler(this.mnuPrintReminderLetters_Click);
@@ -462,6 +462,7 @@
             // 
             this.mnuMkRadAppt.Index = 2;
-            this.mnuMkRadAppt.Shortcut = System.Windows.Forms.Shortcut.Ins;
+            this.mnuMkRadAppt.Shortcut = System.Windows.Forms.Shortcut.CtrlIns;
             this.mnuMkRadAppt.Text = "Make Radiology Appointment";
+            this.mnuMkRadAppt.Click += new System.EventHandler(this.mnuMkRadAppt_Click);
             // 
             // mnuEditAppointment
@@ -482,6 +483,7 @@
             // 
             this.mnuCancelRadAppt.Index = 5;
-            this.mnuCancelRadAppt.Shortcut = System.Windows.Forms.Shortcut.Del;
+            this.mnuCancelRadAppt.Shortcut = System.Windows.Forms.Shortcut.CtrlDel;
             this.mnuCancelRadAppt.Text = "Cancel Radiology Appointment";
+            this.mnuCancelRadAppt.Click += new System.EventHandler(this.mnuCancelRadAppt_Click);
             // 
             // sepApptMenu1
@@ -493,4 +495,5 @@
             // 
             this.mnuNoShow.Index = 7;
+            this.mnuNoShow.Shortcut = System.Windows.Forms.Shortcut.CtrlN;
             this.mnuNoShow.Text = "Mark as No Sho&w";
             this.mnuNoShow.Click += new System.EventHandler(this.mnuNoShow_Click);
@@ -499,4 +502,5 @@
             // 
             this.mnuNoShowUndo.Index = 8;
+            this.mnuNoShowUndo.Shortcut = System.Windows.Forms.Shortcut.CtrlShiftN;
             this.mnuNoShowUndo.Text = "&Undo No Show";
             this.mnuNoShowUndo.Click += new System.EventHandler(this.mnuNoShowUndo_Click);
@@ -510,4 +514,5 @@
             // 
             this.mnuCheckIn.Index = 10;
+            this.mnuCheckIn.Shortcut = System.Windows.Forms.Shortcut.CtrlI;
             this.mnuCheckIn.Text = "Check &In Patient";
             this.mnuCheckIn.Click += new System.EventHandler(this.mnuCheckIn_Click);
@@ -516,5 +521,7 @@
             // 
             this.mnuUndoCheckin.Index = 11;
+            this.mnuUndoCheckin.Shortcut = System.Windows.Forms.Shortcut.CtrlShiftI;
             this.mnuUndoCheckin.Text = "Undo Checkin";
+            this.mnuUndoCheckin.Click += new System.EventHandler(this.mnuUndoCheckin_Click);
             // 
             // sepApptMenu3
@@ -527,5 +534,5 @@
             this.mnuFindAppt.Index = 13;
             this.mnuFindAppt.Shortcut = System.Windows.Forms.Shortcut.CtrlF;
-            this.mnuFindAppt.Text = "&Find Available Appointment";
+            this.mnuFindAppt.Text = "&Find Empty Slots";
             this.mnuFindAppt.Click += new System.EventHandler(this.mnuFindAppt_Click);
             // 
@@ -533,4 +540,5 @@
             // 
             this.mnuCopyAppointment.Index = 14;
+            this.mnuCopyAppointment.Shortcut = System.Windows.Forms.Shortcut.CtrlC;
             this.mnuCopyAppointment.Text = "&Copy  Appointment to Clipboard";
             this.mnuCopyAppointment.Click += new System.EventHandler(this.mnuCopyAppointment_Click);
@@ -539,4 +547,5 @@
             // 
             this.mnuViewPatientAppts.Index = 15;
+            this.mnuViewPatientAppts.Shortcut = System.Windows.Forms.Shortcut.CtrlShiftZ;
             this.mnuViewPatientAppts.Text = "&View Patient Appointments";
             this.mnuViewPatientAppts.Click += new System.EventHandler(this.mnuViewPatientAppts_Click);
@@ -545,5 +554,7 @@
             // 
             this.mnuReprintApptSlip.Index = 16;
+            this.mnuReprintApptSlip.Shortcut = System.Windows.Forms.Shortcut.CtrlShiftP;
             this.mnuReprintApptSlip.Text = "Reprint Appointment Slip";
+            this.mnuReprintApptSlip.Click += new System.EventHandler(this.mnuReprintApptSlip_Click);
             // 
             // mnuCalendar
@@ -701,5 +712,5 @@
             this.tvSchedules.Location = new System.Drawing.Point(0, 0);
             this.tvSchedules.Name = "tvSchedules";
-            this.tvSchedules.Size = new System.Drawing.Size(128, 396);
+            this.tvSchedules.Size = new System.Drawing.Size(128, 392);
             this.tvSchedules.Sorted = true;
             this.tvSchedules.TabIndex = 1;
@@ -743,5 +754,5 @@
             // 
             this.ctxFindAppt.Index = 3;
-            this.ctxFindAppt.Text = "&Find Available Appointment";
+            this.ctxFindAppt.Text = "&Find Empty Slots";
             this.ctxFindAppt.Click += new System.EventHandler(this.ctxFindAppt_Click);
             // 
@@ -770,5 +781,5 @@
             this.panelRight.Location = new System.Drawing.Point(996, 0);
             this.panelRight.Name = "panelRight";
-            this.panelRight.Size = new System.Drawing.Size(128, 396);
+            this.panelRight.Size = new System.Drawing.Size(128, 392);
             this.panelRight.TabIndex = 3;
             this.panelRight.Visible = false;
@@ -866,6 +877,141 @@
             this.panelCenter.Location = new System.Drawing.Point(136, 24);
             this.panelCenter.Name = "panelCenter";
-            this.panelCenter.Size = new System.Drawing.Size(857, 348);
+            this.panelCenter.Size = new System.Drawing.Size(857, 344);
             this.panelCenter.TabIndex = 7;
+            // 
+            // ctxCalendarGrid
+            // 
+            this.ctxCalendarGrid.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
+            this.ctxCalGridAdd,
+            this.ctxCalGridMkRadAppt,
+            this.ctxCalGridEdit,
+            this.ctxCalGridDelete,
+            this.ctxCalGridCancelRadAppt,
+            this.ctxCalGridCheckIn,
+            this.ctxCalGridUndoCheckin,
+            this.ctxCalGridSep1,
+            this.ctxCalGridNoShow,
+            this.ctxCalGridNoShowUndo,
+            this.ctxCalGridSep2,
+            this.ctxCalGridWalkin,
+            this.ctxCalGridSep3,
+            this.ctxCalGridReprintApptSlip});
+            this.ctxCalendarGrid.Popup += new System.EventHandler(this.ctxCalendarGrid_Popup);
+            // 
+            // ctxCalGridAdd
+            // 
+            this.ctxCalGridAdd.Index = 0;
+            this.ctxCalGridAdd.Text = "Add Appointment";
+            this.ctxCalGridAdd.Click += new System.EventHandler(this.ctxCalGridAdd_Click);
+            // 
+            // ctxCalGridMkRadAppt
+            // 
+            this.ctxCalGridMkRadAppt.Index = 1;
+            this.ctxCalGridMkRadAppt.Text = "Make Radiology Appointment";
+            this.ctxCalGridMkRadAppt.Click += new System.EventHandler(this.ctxCalGridMkRadAppt_Click);
+            // 
+            // ctxCalGridEdit
+            // 
+            this.ctxCalGridEdit.Index = 2;
+            this.ctxCalGridEdit.Text = "Edit Appointment";
+            this.ctxCalGridEdit.Click += new System.EventHandler(this.ctxCalGridEdit_Click);
+            // 
+            // ctxCalGridDelete
+            // 
+            this.ctxCalGridDelete.Index = 3;
+            this.ctxCalGridDelete.Text = "Cancel Appointment";
+            this.ctxCalGridDelete.Click += new System.EventHandler(this.ctxCalGridDelete_Click);
+            // 
+            // ctxCalGridCancelRadAppt
+            // 
+            this.ctxCalGridCancelRadAppt.Index = 4;
+            this.ctxCalGridCancelRadAppt.Text = "Cancel Radiology Appointment";
+            this.ctxCalGridCancelRadAppt.Click += new System.EventHandler(this.ctxCalGridCancelRadAppt_Click);
+            // 
+            // ctxCalGridCheckIn
+            // 
+            this.ctxCalGridCheckIn.Index = 5;
+            this.ctxCalGridCheckIn.Text = "Check In Patient";
+            this.ctxCalGridCheckIn.Click += new System.EventHandler(this.ctxCalGridCheckIn_Click);
+            // 
+            // ctxCalGridUndoCheckin
+            // 
+            this.ctxCalGridUndoCheckin.Index = 6;
+            this.ctxCalGridUndoCheckin.Text = "&Undo Check In";
+            this.ctxCalGridUndoCheckin.Click += new System.EventHandler(this.ctxCalGridUndoCheckin_Click);
+            // 
+            // ctxCalGridSep1
+            // 
+            this.ctxCalGridSep1.Index = 7;
+            this.ctxCalGridSep1.Text = "-";
+            // 
+            // ctxCalGridNoShow
+            // 
+            this.ctxCalGridNoShow.Index = 8;
+            this.ctxCalGridNoShow.Text = "Mark as No Show";
+            this.ctxCalGridNoShow.Click += new System.EventHandler(this.ctxCalGridNoShow_Click);
+            // 
+            // ctxCalGridNoShowUndo
+            // 
+            this.ctxCalGridNoShowUndo.Index = 9;
+            this.ctxCalGridNoShowUndo.Text = "Undo NoShow";
+            this.ctxCalGridNoShowUndo.Click += new System.EventHandler(this.ctxCalGridNoShowUndo_Click);
+            // 
+            // ctxCalGridSep2
+            // 
+            this.ctxCalGridSep2.Index = 10;
+            this.ctxCalGridSep2.Text = "-";
+            // 
+            // ctxCalGridWalkin
+            // 
+            this.ctxCalGridWalkin.Index = 11;
+            this.ctxCalGridWalkin.Text = "Create Wal&k-In Appointment";
+            this.ctxCalGridWalkin.Click += new System.EventHandler(this.ctxCalGridWalkin_Click);
+            // 
+            // ctxCalGridSep3
+            // 
+            this.ctxCalGridSep3.Index = 12;
+            this.ctxCalGridSep3.Text = "-";
+            // 
+            // ctxCalGridReprintApptSlip
+            // 
+            this.ctxCalGridReprintApptSlip.Index = 13;
+            this.ctxCalGridReprintApptSlip.Text = "&Reprint Appointment Slip";
+            this.ctxCalGridReprintApptSlip.Click += new System.EventHandler(this.ctxCalGridReprintApptSlip_Click);
+            // 
+            // panelBottom
+            // 
+            this.panelBottom.Controls.Add(this.statusBar1);
+            this.panelBottom.Dock = System.Windows.Forms.DockStyle.Bottom;
+            this.panelBottom.Location = new System.Drawing.Point(136, 368);
+            this.panelBottom.Name = "panelBottom";
+            this.panelBottom.Size = new System.Drawing.Size(857, 24);
+            this.panelBottom.TabIndex = 8;
+            // 
+            // statusBar1
+            // 
+            this.statusBar1.Dock = System.Windows.Forms.DockStyle.Fill;
+            this.statusBar1.Location = new System.Drawing.Point(0, 0);
+            this.statusBar1.Name = "statusBar1";
+            this.statusBar1.Size = new System.Drawing.Size(857, 24);
+            this.statusBar1.SizingGrip = false;
+            this.statusBar1.TabIndex = 0;
+            // 
+            // splitter1
+            // 
+            this.splitter1.Location = new System.Drawing.Point(128, 24);
+            this.splitter1.Name = "splitter1";
+            this.splitter1.Size = new System.Drawing.Size(8, 368);
+            this.splitter1.TabIndex = 9;
+            this.splitter1.TabStop = false;
+            // 
+            // splitter2
+            // 
+            this.splitter2.Dock = System.Windows.Forms.DockStyle.Right;
+            this.splitter2.Location = new System.Drawing.Point(993, 24);
+            this.splitter2.Name = "splitter2";
+            this.splitter2.Size = new System.Drawing.Size(3, 368);
+            this.splitter2.TabIndex = 10;
+            this.splitter2.TabStop = false;
             // 
             // calendarGrid1
@@ -888,5 +1034,5 @@
             this.calendarGrid1.Resources = ((System.Collections.ArrayList)(resources.GetObject("calendarGrid1.Resources")));
             this.calendarGrid1.SelectedAppointment = 0;
-            this.calendarGrid1.Size = new System.Drawing.Size(857, 348);
+            this.calendarGrid1.Size = new System.Drawing.Size(857, 344);
             this.calendarGrid1.StartDate = new System.DateTime(2003, 1, 27, 0, 0, 0, 0);
             this.calendarGrid1.TabIndex = 0;
@@ -898,143 +1044,8 @@
             this.calendarGrid1.MouseEnter += new System.EventHandler(this.calendarGrid1_MouseEnter);
             // 
-            // ctxCalendarGrid
-            // 
-            this.ctxCalendarGrid.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
-            this.ctxCalGridAdd,
-            this.ctxCalGridMkRadAppt,
-            this.ctxCalGridEdit,
-            this.ctxCalGridDelete,
-            this.ctxCalGridCancelRadAppt,
-            this.ctxCalGridCheckIn,
-            this.ctxCalGridUndoCheckin,
-            this.menuItem2,
-            this.ctxCalGridNoShow,
-            this.ctxCalGridNoShowUndo,
-            this.menuItem9,
-            this.ctxCalGridWalkin,
-            this.menuItem10,
-            this.ctxCalGridReprintApptSlip});
-            this.ctxCalendarGrid.Popup += new System.EventHandler(this.ctxCalendarGrid_Popup);
-            // 
-            // ctxCalGridAdd
-            // 
-            this.ctxCalGridAdd.Index = 0;
-            this.ctxCalGridAdd.Text = "Add Appointment";
-            this.ctxCalGridAdd.Click += new System.EventHandler(this.ctxCalGridAdd_Click);
-            // 
-            // ctxCalGridMkRadAppt
-            // 
-            this.ctxCalGridMkRadAppt.Index = 1;
-            this.ctxCalGridMkRadAppt.Text = "Make Radiology Appointment";
-            this.ctxCalGridMkRadAppt.Click += new System.EventHandler(this.ctxCalGridMkRadAppt_Click);
-            // 
-            // ctxCalGridEdit
-            // 
-            this.ctxCalGridEdit.Index = 2;
-            this.ctxCalGridEdit.Text = "Edit Appointment";
-            this.ctxCalGridEdit.Click += new System.EventHandler(this.ctxCalGridEdit_Click);
-            // 
-            // ctxCalGridDelete
-            // 
-            this.ctxCalGridDelete.Index = 3;
-            this.ctxCalGridDelete.Text = "Cancel Appointment";
-            this.ctxCalGridDelete.Click += new System.EventHandler(this.ctxCalGridDelete_Click);
-            // 
-            // ctxCalGridCancelRadAppt
-            // 
-            this.ctxCalGridCancelRadAppt.Index = 4;
-            this.ctxCalGridCancelRadAppt.Text = "Cancel Radiology Appointment";
-            this.ctxCalGridCancelRadAppt.Click += new System.EventHandler(this.ctxCalGridCancelRadAppt_Click);
-            // 
-            // ctxCalGridCheckIn
-            // 
-            this.ctxCalGridCheckIn.Index = 5;
-            this.ctxCalGridCheckIn.Text = "Check In Patient";
-            this.ctxCalGridCheckIn.Click += new System.EventHandler(this.ctxCalGridCheckIn_Click);
-            // 
-            // ctxCalGridUndoCheckin
-            // 
-            this.ctxCalGridUndoCheckin.Index = 6;
-            this.ctxCalGridUndoCheckin.Text = "&Undo Check In";
-            this.ctxCalGridUndoCheckin.Click += new System.EventHandler(this.ctxCalGridUndoCheckin_Click);
-            // 
-            // menuItem2
-            // 
-            this.menuItem2.Index = 7;
-            this.menuItem2.Text = "-";
-            // 
-            // ctxCalGridNoShow
-            // 
-            this.ctxCalGridNoShow.Index = 8;
-            this.ctxCalGridNoShow.Text = "Mark as No Show";
-            this.ctxCalGridNoShow.Click += new System.EventHandler(this.ctxCalGridNoShow_Click);
-            // 
-            // ctxCalGridNoShowUndo
-            // 
-            this.ctxCalGridNoShowUndo.Index = 9;
-            this.ctxCalGridNoShowUndo.Text = "Undo NoShow";
-            this.ctxCalGridNoShowUndo.Click += new System.EventHandler(this.ctxCalGridNoShowUndo_Click);
-            // 
-            // menuItem9
-            // 
-            this.menuItem9.Index = 10;
-            this.menuItem9.Text = "-";
-            // 
-            // ctxCalGridWalkin
-            // 
-            this.ctxCalGridWalkin.Index = 11;
-            this.ctxCalGridWalkin.Text = "Create Wal&k-In Appointment";
-            this.ctxCalGridWalkin.Click += new System.EventHandler(this.ctxCalGridWalkin_Click);
-            // 
-            // menuItem10
-            // 
-            this.menuItem10.Index = 12;
-            this.menuItem10.Text = "-";
-            // 
-            // ctxCalGridReprintApptSlip
-            // 
-            this.ctxCalGridReprintApptSlip.Index = 13;
-            this.ctxCalGridReprintApptSlip.Text = "&Reprint Appointment Slip";
-            this.ctxCalGridReprintApptSlip.Click += new System.EventHandler(this.ctxCalGridReprintApptSlip_Click);
-            // 
-            // panelBottom
-            // 
-            this.panelBottom.Controls.Add(this.statusBar1);
-            this.panelBottom.Dock = System.Windows.Forms.DockStyle.Bottom;
-            this.panelBottom.Location = new System.Drawing.Point(136, 372);
-            this.panelBottom.Name = "panelBottom";
-            this.panelBottom.Size = new System.Drawing.Size(857, 24);
-            this.panelBottom.TabIndex = 8;
-            // 
-            // statusBar1
-            // 
-            this.statusBar1.Dock = System.Windows.Forms.DockStyle.Fill;
-            this.statusBar1.Location = new System.Drawing.Point(0, 0);
-            this.statusBar1.Name = "statusBar1";
-            this.statusBar1.Size = new System.Drawing.Size(857, 24);
-            this.statusBar1.SizingGrip = false;
-            this.statusBar1.TabIndex = 0;
-            // 
-            // splitter1
-            // 
-            this.splitter1.Location = new System.Drawing.Point(128, 24);
-            this.splitter1.Name = "splitter1";
-            this.splitter1.Size = new System.Drawing.Size(8, 372);
-            this.splitter1.TabIndex = 9;
-            this.splitter1.TabStop = false;
-            // 
-            // splitter2
-            // 
-            this.splitter2.Dock = System.Windows.Forms.DockStyle.Right;
-            this.splitter2.Location = new System.Drawing.Point(993, 24);
-            this.splitter2.Name = "splitter2";
-            this.splitter2.Size = new System.Drawing.Size(3, 372);
-            this.splitter2.TabIndex = 10;
-            this.splitter2.TabStop = false;
-            // 
             // CGView
             // 
             this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
-            this.ClientSize = new System.Drawing.Size(1124, 396);
+            this.ClientSize = new System.Drawing.Size(1124, 392);
             this.Controls.Add(this.panelCenter);
             this.Controls.Add(this.panelBottom);
@@ -1238,4 +1249,29 @@
         }
 
+        private void mnuMkRadAppt_Click(object sender, EventArgs e)
+        {
+            AppointmentAddNewRadiology();
+        }
+
+        private void mnuCancelRadAppt_Click(object sender, EventArgs e)
+        {
+            AppointmentDeleteOneRadiology();
+        }
+
+        private void mnuUndoCheckin_Click(object sender, EventArgs e)
+        {
+            AppointmentUndoCheckin();
+        }
+
+        private void mnuReprintApptSlip_Click(object sender, EventArgs e)
+        {
+            int apptID = this.CGrid.SelectedAppointment;
+            if (apptID <= 0) return;
+
+            CGAppointment a = (CGAppointment)this.Appointments.AppointmentTable[apptID];
+
+            PrintAppointmentSlip(a);
+        }
+
 		#endregion AppointmentMenu Handlers
 
@@ -1378,4 +1414,6 @@
                 ctxCalGridWalkin.Visible = false;
                 ctxCalGridUndoCheckin.Visible = false;
+                ctxCalGridSep1.Visible = false;
+                ctxCalGridSep2.Visible = false;
 
                 ctxCalGridMkRadAppt.Visible = true;
@@ -1395,4 +1433,6 @@
                 ctxCalGridWalkin.Visible = true;
                 ctxCalGridUndoCheckin.Visible = true;
+                ctxCalGridSep1.Visible = true;
+                ctxCalGridSep2.Visible = true;
 
                 ctxCalGridMkRadAppt.Visible = false;
@@ -1464,5 +1504,4 @@
         }
 
-        //new code smh
         private void ctxCalGridReprintApptSlip_Click(object sender, EventArgs e)
         {
@@ -1474,5 +1513,4 @@
             PrintAppointmentSlip(a);
         }
-        //end new code
 
 		#endregion ctxCalGridMenu Handlers
@@ -1480,7 +1518,13 @@
 		#region Methods
 
+        /// <summary>
+        /// Decides whether this is a Radiology Resource. Local Helper to decide what menu items to enable/display
+        /// </summary>
+        /// <returns></returns>
         private bool IsThisARadiologyResource()
         {
-            // I don't like this logic!!! but works for now!
+            //I don't like this logic!!! but works for now!
+            //Note: I use banana peeling model below
+
             //If no cell is selected AND no appointment is selected, then it's false
             if (this.calendarGrid1.SelectedRange.Cells.CellCount < 1 && this.calendarGrid1.SelectedAppointment < 1)
@@ -1491,10 +1535,11 @@
             {
                 CGAppointment appt = this.Appointments.AppointmentTable[this.calendarGrid1.SelectedAppointment] as CGAppointment;
-                if (appt.RadiologyExamIEN.HasValue && appt.RadiologyExamIEN.Value > 0) return true;
+                if (appt == null) return false; //appt doesn't exist; old appointment and grid wasn't refreshed yet
+                if (appt.RadiologyExamIEN.HasValue && appt.RadiologyExamIEN.Value > 0) return true; //this appointment is a radiology appointment since it has that member
                 else return false;
 
             }
 
-            //Otherwise, we are forsure dealing with a cell.
+            //Otherwise, we are for sure dealing with a cell.
             //We need to determine if the cell resource is mapped to a Radiology Hospital Location.
             DateTime dStart;
@@ -1512,12 +1557,22 @@
 
             // see if resource is mapped to a Radiology Hospital Location.
-            return (from hl in CGDocumentManager.Current.GlobalDataSet.Tables["HospitalLocation"].AsEnumerable()
-                       where hl.Field<string>("IS_RADIOLOGY_LOCATION")=="1"
+            return IsThisARadiologyResource(sResource);
+        }
+
+        private bool IsThisARadiologyResource(string sResource)
+        {
+            // see if resource is mapped to a Radiology Hospital Location.
+            return (   //select all Hospital Locations which are radiology locations
+                       from hl in CGDocumentManager.Current.GlobalDataSet.Tables["HospitalLocation"].AsEnumerable()
+                       where hl.Field<string>("IS_RADIOLOGY_LOCATION") == "1"
+                       //join this to the resources table using the foreign ID (plain jane relational join)
                        join res in CGDocumentManager.Current.GlobalDataSet.Tables["Resources"].AsEnumerable()
                        on hl.Field<int>("HOSPITAL_LOCATION_ID") equals res.Field<int>("HOSPITAL_LOCATION_ID")
+                       //then filter this down to the resource that we have
                        where res.Field<string>("RESOURCE_NAME") == sResource
+                       //if we have any row left, then it is true.
                        select hl).Any();
         }
-        
+
         private bool EditAppointmentEnabled()
         {
@@ -1980,4 +2035,14 @@
 				this.Document.EditAppointment(a, sNote);
 
+                if (dAppt.PrintAppointmentSlip)
+                {
+                    PrintAppointmentSlip(a);
+                }
+
+                //Redraw appointments
+                this.UpdateArrays();
+
+                //Then tell RPMS that we are updated
+                RaiseRPMSEvent("BSDX SCHEDULE", a.Resource);
 			}
 			catch (Exception ex)
@@ -2130,4 +2195,7 @@
 		}
 
+        /// <summary>
+        /// Delete one Radiology Appointment
+        /// </summary>
         private void AppointmentDeleteOneRadiology()
         {
@@ -2137,4 +2205,7 @@
 
             Debug.Assert(a.RadiologyExamIEN.HasValue);
+
+            //Prior to making expensive db calls, tell the grid nothing is selected anymore so nobody would try to pick it up
+            this.calendarGrid1.SelectedAppointment = 0;
 
             //Cancel Radiology Exam
@@ -2171,5 +2242,5 @@
                 if (a.CheckInTime.Ticks > 0)
                 {
-                    MessageBox.Show("You must Un-checkin the appointment first before removing it.");
+                    MessageBox.Show("You must undo the check-in first before removing the appointment.");
                     return;
                 }
@@ -2183,4 +2254,9 @@
                 return;
             }
+
+            //At this point, the appointment will be deleted...
+            //Remove the Selected Appointment from the grid because we don't anybody to think there's still
+            //an appointment selected while we are still updating the grid
+            this.calendarGrid1.SelectedAppointment = 0;
 
             bool bClinic = dCancel.ClinicCancelled;
@@ -2549,12 +2625,19 @@
 		}
 
+        /// <summary>
+        /// Add a new Radiology Appointment to VISTA (ÒÝÊì as my mom calls it)
+        /// </summary>
         private void AppointmentAddNewRadiology()
         {
-            DateTime dStart, dEnd;
-            string sResource;
-            int nAccessTypeID = 0;
+            DateTime dStart, dEnd;  //return vales for below
+            string sResource;       //ditto
+            int nAccessTypeID = 0;  //ditto
 
             this.calendarGrid1.GetSelectedTime(out dStart, out dEnd, out sResource);
             this.calendarGrid1.GetSelectedType(out nAccessTypeID);
+
+            Debug.Assert(sResource != null);
+            Debug.Assert(dStart > DateTime.MinValue);
+
             //Display a dialog to collect Patient Name
             DPatientLookup dPat = new DPatientLookup();
@@ -2567,10 +2650,13 @@
 
             int DFN = Int32.Parse(dPat.PatientIEN);
+            // Hospital Location IEN
             int hlIEN = (from resource in CGDocumentManager.Current.GlobalDataSet.Tables["Resources"].AsEnumerable()
                          where resource.Field<string>("RESOURCE_NAME") == sResource
                          select resource.Field<int>("HOSPITAL_LOCATION_ID")).FirstOrDefault();
 
+            //Get Radiology Exams from the DB
             List<RadiologyExam> _radExams = CGDocumentManager.Current.DAL.GetRadiologyExamsForPatientinHL(DFN, hlIEN);
 
+            //If none found...
             if (!_radExams.Any())
             {
@@ -2579,12 +2665,15 @@
             }
 
+            //Display a form for the user to select radiology exams.
             DRadExamsSelect _radform = new DRadExamsSelect(_radExams);
 
             if (_radform.ShowDialog() == DialogResult.Cancel) return;
 
+            //Get some return values
             int _examien = _radform.ExamIEN;
             string _procedurename = _radform.ProcedureName;
 
-            CGDocumentManager.Current.DAL.ScheduleRadiologyExam(DFN, _examien);
+            //Save Radiology Exam Schedule Info to Radiology Package
+            CGDocumentManager.Current.DAL.ScheduleRadiologyExam(DFN, _examien, dStart);
 
             //Now create and save the appointment
@@ -2596,5 +2685,17 @@
             appt.AccessTypeID = nAccessTypeID;
             appt.RadiologyExamIEN = _examien;
+            appt.Patient = new Patient
+            {
+                DFN = Convert.ToInt32(dPat.PatientIEN),
+                ID = dPat.PatientPID,
+                Name = dPat.PatientName,
+                HRN = dPat.HealthRecordNumber,
+                DOB = dPat.PatientDOB
+            };
+
             this.Document.CreateAppointment(appt);
+
+            //Print Appointment Slip if requested
+            if (_radform.PrintAppointmentSlip) this.PrintAppointmentSlip(appt);
 
             //Now redraw the grid to display the new appointments
@@ -2919,6 +3020,4 @@
 			this.calendarGrid1.Columns = 5;
             this.Document.m_nColumnCount = 5; // MJL 1/17/2007
-            //this.Document.UpdateAllViews();
-            //TODO: Is there a way to just reuse the existing arrays? How far in the future do they go?
             RequestRefreshGrid();
 		}
@@ -2928,5 +3027,4 @@
 			this.calendarGrid1.Columns = 7;
             this.Document.m_nColumnCount = 7; // MJL 1/17/2007
-            //TODO: Is there a way to just reuse the existing arrays? How far in the future do they go?
             RequestRefreshGrid();
         }
@@ -3122,4 +3220,12 @@
                 {
                     MessageBox.Show("You cannot move a radiology appointment.", "Clinical Scheduling");
+                    return;
+                }
+
+                // added May 5 2011
+                // Can't move an appointment to a radiology resource
+                if (IsThisARadiologyResource(e.Resource))
+                {
+                    MessageBox.Show("You cannot move an appointment to a radiology location.", "Clinical Scheduling");
                     return;
                 }
@@ -3196,4 +3302,6 @@
                 appt.HealthRecordNumber = e.Appointment.HealthRecordNumber;
                 appt.AccessTypeID = e.AccessTypeID;
+                appt.Patient = e.Appointment.Patient;
+
                 this.Document.CreateAppointment(appt);
 
@@ -3751,23 +3859,32 @@
         }
 
-        LoadingSplash _loadingSplash; // Splash object a data point in class
+        //private delegate DialogResult dLoadingSplash(IWin32Window owner);
+        string _tempStatusBartext;
 
         /// <summary>
-        /// Loads a splash that says "Loading"
+        /// Loads a splash that says "Loading" -- removed it april 13 2010
         /// </summary>
         private void LoadSplash()
         {
-            _loadingSplash = new LoadingSplash();
-            _loadingSplash.StartPosition = FormStartPosition.CenterScreen;  //XXX: Don't like this, but will do for now.
-            _loadingSplash.UseWaitCursor = true;    // tell user we are working
-            Thread threadSplash = new Thread(new ThreadStart(() => _loadingSplash.ShowDialog())); // lambda
-            threadSplash.IsBackground = true; //expendable thread -- exit even if still running.
-            threadSplash.Name = "Loading Thread";
-            threadSplash.Start();
+            _tempStatusBartext = this.statusBar1.Text;
+            this.statusBar1.Text = "Refreshing Schedule...";
+            //_loadingSplash = new LoadingSplash();
+            //_loadingSplash.StartPosition = FormStartPosition.CenterScreen;  //XXX: Don't like this, but will do for now.
+            //_loadingSplash.UseWaitCursor = true;    // tell user we are working
+            //_loadingSplash.Show(this);
+            //Thread threadSplash = new Thread(tstart);
+            //threadSplash.IsBackground = true;
+            //threadSplash.Name = "Loading Thread";
+            //threadSplash.Start(this);
+
+            //Thread threadSplash = new Thread(new ThreadStart(() => _loadingSplash.ShowDialog())); // lambda
+            //threadSplash.IsBackground = true; //expendable thread -- exit even if still running.
+            //threadSplash.Name = "Loading Thread";
+            //threadSplash.Start();
         }
 
         private void StopSplash()
         {
-            _loadingSplash.RemoteClose();
+            this.statusBar1.Text = _tempStatusBartext;
         }
 
@@ -3787,4 +3904,5 @@
         }
 
+
     }//End class
 }